/*
 *  Signed and unsigned bit picking.
 */

/* unsigned bit picking */

#define vm_u2bits(value)	((value)&0x03)
#define vm_u6bits(value)	((value)&0x3F)
#define vm_u8bits(value)	((value)&0x00FF)
#define vm_u14bits(value)	((value)&0x3FFF)
#define vm_u22bits(value)	((value)&0x3FFFFF)

/* signed bit picking */

long vm_s6bits(long value);
long vm_s14bits(long value);
long vm_s22bits(long value);

/* checking packing requirements */

#define vm_is_u2bits(value)   ((value)==vm_u2bits(value))
#define vm_is_u6bits(value)   ((value)==vm_u6bits(value))
#define vm_is_u8bits(value)   ((value)==vm_u8bits(value))
#define vm_is_u14bits(value)  ((value)==vm_u14bits(value))
#define vm_is_u22bits(value)  ((value)==vm_u22bits(value))

#define vm_is_s6bits(value)   ((value)==vm_s6bits(value))
#define vm_is_s14bits(value)  ((value)==vm_s14bits(value))
#define vm_is_s22bits(value)  ((value)==vm_s22bits(value))

