/*
 *  Tokeniser definitions:
 */

  enum TokenKind {
	ERROR=0, ENDOFFILE, NEWLINE,
	CODE, INT, DOUBLE, STRING,
	OPCODE, INTVAL, DOUBLEVAL, STRINGVAL,
	IDENT, REG, CELL,
	LSHIFT, RSHIFT, LPARENTH, RPARENTH,
	LBRACE, RBRACE, LBRACKET, RBRACKET,
	EQUALITY, INEQUALITY, LTEQ, GTEQ, LT, GT, EQUALS,
	COMMA, SEMICOLON, STAR, SLASH, MOD, PLUS, MINUS,
	BITWISE_AND, BITWISE_OR, BITWISE_XOR, BITWISE_NOT,
	BACKSLASH, QUOTE, DOT, COLON,
	PC,
  };

  typedef struct Token * Token;
  struct Token {	// one parser token
 	Token	next;	// next in hash table
	long	line;	// line number, 0 for keywords
	int	kind;	// EOF, ERROR, INT, INTVAL, EQUALS, etc
	long	num;	// integer value associated with this token
	double	real;	// floating-point value
	char *	name;	// string value (malloc'd)
 };

/*
 *  Tokeniser functions:
 */

extern	char * TokenNames[];

void	init_tokeniser(void);
void	print_token(Token t);
void	print_all_tokens(void);

Token	new_token(void);
Token	add_token(Token t);

