/*
 *  Assembler
 *
 *  Valid Operand Modes Table
 *  Do not edit this machine generated file (use genvalid.py)
 */

#include "asm.h"

static ValidMode halt_valid [] = {
	{ "---", 0 },
	{ "",   -1 }
};

static ValidMode nop_valid [] = {
	{ "---", 0 },
	{ "",   -1 }
};

static ValidMode bra_valid [] = {
	{ "A--", 1 },
	{ "S--", 1 },
	{ "R--", 1 },
	{ "",   -1 }
};

static ValidMode bgt_valid [] = {
	{ "A--", 1 },
	{ "S--", 1 },
	{ "R--", 1 },
	{ "",   -1 }
};

static ValidMode bge_valid [] = {
	{ "A--", 1 },
	{ "S--", 1 },
	{ "R--", 1 },
	{ "",   -1 }
};

static ValidMode blt_valid [] = {
	{ "A--", 1 },
	{ "S--", 1 },
	{ "R--", 1 },
	{ "",   -1 }
};

static ValidMode ble_valid [] = {
	{ "A--", 1 },
	{ "S--", 1 },
	{ "R--", 1 },
	{ "",   -1 }
};

static ValidMode beq_valid [] = {
	{ "A--", 1 },
	{ "S--", 1 },
	{ "R--", 1 },
	{ "",   -1 }
};

static ValidMode bne_valid [] = {
	{ "A--", 1 },
	{ "S--", 1 },
	{ "R--", 1 },
	{ "",   -1 }
};

static ValidMode beof_valid [] = {
	{ "A--", 1 },
	{ "S--", 1 },
	{ "R--", 1 },
	{ "",   -1 }
};

static ValidMode call_valid [] = {
	{ "A--", 1 },
	{ "S--", 1 },
	{ "R--", 1 },
	{ "",   -1 }
};

static ValidMode ret_valid [] = {
	{ "---", 0 },
	{ "",   -1 }
};

static ValidMode inew_valid [] = {
	{ "--r", 1 },
	{ "--c", 1 },
	{ "",   -1 }
};

static ValidMode iabs_valid [] = {
	{ "l-r", 2 },
	{ "L-r", 2 },
	{ "r-r", 2 },
	{ "i-r", 2 },
	{ "l-c", 2 },
	{ "L-c", 2 },
	{ "r-c", 2 },
	{ "i-c", 2 },
	{ "",   -1 }
};

static ValidMode ipush_valid [] = {
	{ "l--", 1 },
	{ "L--", 1 },
	{ "r--", 1 },
	{ "i--", 1 },
	{ "",   -1 }
};

static ValidMode ipop_valid [] = {
	{ "--r", 1 },
	{ "--c", 1 },
	{ "",   -1 }
};

static ValidMode icmp_valid [] = {
	{ "ll-", 2 },
	{ "L-l", 2 },
	{ "lr-", 2 },
	{ "L-r", 2 },
	{ "li-", 2 },
	{ "L-i", 2 },
	{ "rl-", 2 },
	{ "rr-", 2 },
	{ "ri-", 2 },
	{ "il-", 2 },
	{ "ir-", 2 },
	{ "ii-", 2 },
	{ "",   -1 }
};

static ValidMode iread_valid [] = {
	{ "--r", 1 },
	{ "--c", 1 },
	{ "",   -1 }
};

static ValidMode iprint_valid [] = {
	{ "l--", 1 },
	{ "L--", 1 },
	{ "r--", 1 },
	{ "i--", 1 },
	{ "",   -1 }
};

static ValidMode iadd_valid [] = {
	{ "L-r", 2 },
	{ "llr", 3 },
	{ "lrr", 3 },
	{ "lir", 3 },
	{ "rlr", 3 },
	{ "rrr", 3 },
	{ "rir", 3 },
	{ "ilr", 3 },
	{ "irr", 3 },
	{ "iir", 3 },
	{ "L-i", 2 },
	{ "llc", 3 },
	{ "lrc", 3 },
	{ "lic", 3 },
	{ "rlc", 3 },
	{ "rrc", 3 },
	{ "ric", 3 },
	{ "ilc", 3 },
	{ "irc", 3 },
	{ "iic", 3 },
	{ "",   -1 }
};

static ValidMode isub_valid [] = {
	{ "L-r", 2 },
	{ "llr", 3 },
	{ "lrr", 3 },
	{ "lir", 3 },
	{ "rlr", 3 },
	{ "rrr", 3 },
	{ "rir", 3 },
	{ "ilr", 3 },
	{ "irr", 3 },
	{ "iir", 3 },
	{ "L-i", 2 },
	{ "llc", 3 },
	{ "lrc", 3 },
	{ "lic", 3 },
	{ "rlc", 3 },
	{ "rrc", 3 },
	{ "ric", 3 },
	{ "ilc", 3 },
	{ "irc", 3 },
	{ "iic", 3 },
	{ "",   -1 }
};

static ValidMode imul_valid [] = {
	{ "L-r", 2 },
	{ "llr", 3 },
	{ "lrr", 3 },
	{ "lir", 3 },
	{ "rlr", 3 },
	{ "rrr", 3 },
	{ "rir", 3 },
	{ "ilr", 3 },
	{ "irr", 3 },
	{ "iir", 3 },
	{ "L-i", 2 },
	{ "llc", 3 },
	{ "lrc", 3 },
	{ "lic", 3 },
	{ "rlc", 3 },
	{ "rrc", 3 },
	{ "ric", 3 },
	{ "ilc", 3 },
	{ "irc", 3 },
	{ "iic", 3 },
	{ "",   -1 }
};

static ValidMode idiv_valid [] = {
	{ "L-r", 2 },
	{ "llr", 3 },
	{ "lrr", 3 },
	{ "lir", 3 },
	{ "rlr", 3 },
	{ "rrr", 3 },
	{ "rir", 3 },
	{ "ilr", 3 },
	{ "irr", 3 },
	{ "iir", 3 },
	{ "L-i", 2 },
	{ "llc", 3 },
	{ "lrc", 3 },
	{ "lic", 3 },
	{ "rlc", 3 },
	{ "rrc", 3 },
	{ "ric", 3 },
	{ "ilc", 3 },
	{ "irc", 3 },
	{ "iic", 3 },
	{ "",   -1 }
};

static ValidMode imod_valid [] = {
	{ "L-r", 2 },
	{ "llr", 3 },
	{ "lrr", 3 },
	{ "lir", 3 },
	{ "rlr", 3 },
	{ "rrr", 3 },
	{ "rir", 3 },
	{ "ilr", 3 },
	{ "irr", 3 },
	{ "iir", 3 },
	{ "L-i", 2 },
	{ "llc", 3 },
	{ "lrc", 3 },
	{ "lic", 3 },
	{ "rlc", 3 },
	{ "rrc", 3 },
	{ "ric", 3 },
	{ "ilc", 3 },
	{ "irc", 3 },
	{ "iic", 3 },
	{ "",   -1 }
};

static ValidMode iand_valid [] = {
	{ "L-r", 2 },
	{ "llr", 3 },
	{ "lrr", 3 },
	{ "lir", 3 },
	{ "rlr", 3 },
	{ "rrr", 3 },
	{ "rir", 3 },
	{ "ilr", 3 },
	{ "irr", 3 },
	{ "iir", 3 },
	{ "L-i", 2 },
	{ "llc", 3 },
	{ "lrc", 3 },
	{ "lic", 3 },
	{ "rlc", 3 },
	{ "rrc", 3 },
	{ "ric", 3 },
	{ "ilc", 3 },
	{ "irc", 3 },
	{ "iic", 3 },
	{ "",   -1 }
};

static ValidMode ior_valid [] = {
	{ "L-r", 2 },
	{ "llr", 3 },
	{ "lrr", 3 },
	{ "lir", 3 },
	{ "rlr", 3 },
	{ "rrr", 3 },
	{ "rir", 3 },
	{ "ilr", 3 },
	{ "irr", 3 },
	{ "iir", 3 },
	{ "L-i", 2 },
	{ "llc", 3 },
	{ "lrc", 3 },
	{ "lic", 3 },
	{ "rlc", 3 },
	{ "rrc", 3 },
	{ "ric", 3 },
	{ "ilc", 3 },
	{ "irc", 3 },
	{ "iic", 3 },
	{ "",   -1 }
};

static ValidMode ixor_valid [] = {
	{ "L-r", 2 },
	{ "llr", 3 },
	{ "lrr", 3 },
	{ "lir", 3 },
	{ "rlr", 3 },
	{ "rrr", 3 },
	{ "rir", 3 },
	{ "ilr", 3 },
	{ "irr", 3 },
	{ "iir", 3 },
	{ "L-i", 2 },
	{ "llc", 3 },
	{ "lrc", 3 },
	{ "lic", 3 },
	{ "rlc", 3 },
	{ "rrc", 3 },
	{ "ric", 3 },
	{ "ilc", 3 },
	{ "irc", 3 },
	{ "iic", 3 },
	{ "",   -1 }
};

static ValidMode ilshift_valid [] = {
	{ "L-r", 2 },
	{ "llr", 3 },
	{ "lrr", 3 },
	{ "lir", 3 },
	{ "rlr", 3 },
	{ "rrr", 3 },
	{ "rir", 3 },
	{ "ilr", 3 },
	{ "irr", 3 },
	{ "iir", 3 },
	{ "L-i", 2 },
	{ "llc", 3 },
	{ "lrc", 3 },
	{ "lic", 3 },
	{ "rlc", 3 },
	{ "rrc", 3 },
	{ "ric", 3 },
	{ "ilc", 3 },
	{ "irc", 3 },
	{ "iic", 3 },
	{ "",   -1 }
};

static ValidMode irshift_valid [] = {
	{ "L-r", 2 },
	{ "llr", 3 },
	{ "lrr", 3 },
	{ "lir", 3 },
	{ "rlr", 3 },
	{ "rrr", 3 },
	{ "rir", 3 },
	{ "ilr", 3 },
	{ "irr", 3 },
	{ "iir", 3 },
	{ "L-i", 2 },
	{ "llc", 3 },
	{ "lrc", 3 },
	{ "lic", 3 },
	{ "rlc", 3 },
	{ "rrc", 3 },
	{ "ric", 3 },
	{ "ilc", 3 },
	{ "irc", 3 },
	{ "iic", 3 },
	{ "",   -1 }
};

static ValidMode icopy_valid [] = {
	{ "l-r", 2 },
	{ "L-r", 2 },
	{ "r-r", 2 },
	{ "i-r", 2 },
	{ "l-c", 2 },
	{ "L-c", 2 },
	{ "r-c", 2 },
	{ "i-c", 2 },
	{ "",   -1 }
};

static ValidMode itod_valid [] = {
	{ "l-c", 2 },
	{ "L-c", 2 },
	{ "r-c", 2 },
	{ "i-c", 2 },
	{ "",   -1 }
};

static ValidMode itos_valid [] = {
	{ "l-c", 2 },
	{ "L-c", 2 },
	{ "r-c", 2 },
	{ "i-c", 2 },
	{ "",   -1 }
};

static ValidMode dnew_valid [] = {
	{ "--c", 1 },
	{ "",   -1 }
};

static ValidMode dabs_valid [] = {
	{ "d-c", 2 },
	{ "",   -1 }
};

static ValidMode dpush_valid [] = {
	{ "d--", 1 },
	{ "",   -1 }
};

static ValidMode dpop_valid [] = {
	{ "--c", 1 },
	{ "",   -1 }
};

static ValidMode dcmp_valid [] = {
	{ "dd-", 2 },
	{ "",   -1 }
};

static ValidMode dread_valid [] = {
	{ "--c", 1 },
	{ "",   -1 }
};

static ValidMode dprint_valid [] = {
	{ "d--", 1 },
	{ "",   -1 }
};

static ValidMode dadd_valid [] = {
	{ "ddc", 3 },
	{ "",   -1 }
};

static ValidMode dsub_valid [] = {
	{ "ddc", 3 },
	{ "",   -1 }
};

static ValidMode dmul_valid [] = {
	{ "ddc", 3 },
	{ "",   -1 }
};

static ValidMode ddiv_valid [] = {
	{ "ddc", 3 },
	{ "",   -1 }
};

static ValidMode dtoi_valid [] = {
	{ "d-r", 2 },
	{ "d-c", 2 },
	{ "",   -1 }
};

static ValidMode dcopy_valid [] = {
	{ "d-c", 2 },
	{ "",   -1 }
};

static ValidMode dtos_valid [] = {
	{ "d-c", 2 },
	{ "",   -1 }
};

static ValidMode snew_valid [] = {
	{ "--c", 1 },
	{ "",   -1 }
};

static ValidMode slen_valid [] = {
	{ "s-r", 2 },
	{ "s-c", 2 },
	{ "",   -1 }
};

static ValidMode spush_valid [] = {
	{ "s--", 1 },
	{ "",   -1 }
};

static ValidMode spop_valid [] = {
	{ "--c", 1 },
	{ "",   -1 }
};

static ValidMode scmp_valid [] = {
	{ "ss-", 2 },
	{ "",   -1 }
};

static ValidMode sread_valid [] = {
	{ "--c", 1 },
	{ "",   -1 }
};

static ValidMode sprint_valid [] = {
	{ "s--", 1 },
	{ "",   -1 }
};

static ValidMode sadd_valid [] = {
	{ "ssc", 3 },
	{ "",   -1 }
};

static ValidMode ssub_valid [] = {
	{ "ssc", 3 },
	{ "",   -1 }
};

static ValidMode smul_valid [] = {
	{ "L-s", 2 },
	{ "lsc", 3 },
	{ "rsc", 3 },
	{ "isc", 3 },
	{ "",   -1 }
};

static ValidMode slshift_valid [] = {
	{ "L-s", 2 },
	{ "lsc", 3 },
	{ "rsc", 3 },
	{ "isc", 3 },
	{ "",   -1 }
};

static ValidMode srshift_valid [] = {
	{ "L-s", 2 },
	{ "lsc", 3 },
	{ "rsc", 3 },
	{ "isc", 3 },
	{ "",   -1 }
};

static ValidMode stoi_valid [] = {
	{ "s-r", 2 },
	{ "s-c", 2 },
	{ "",   -1 }
};

static ValidMode stod_valid [] = {
	{ "s-c", 2 },
	{ "",   -1 }
};

static ValidMode scopy_valid [] = {
	{ "s-c", 2 },
	{ "",   -1 }
};

static ValidMode sindex_valid [] = {
	{ "L-s", 2 },
	{ "lsc", 3 },
	{ "rsc", 3 },
	{ "isc", 3 },
	{ "",   -1 }
};

static ValidMode sinsert_valid [] = {
	{ "L-s", 2 },
	{ "lss", 3 },
	{ "rss", 3 },
	{ "iss", 3 },
	{ "",   -1 }
};

static ValidMode sslice_valid [] = {
	{ "lls", 3 },
	{ "lrs", 3 },
	{ "lis", 3 },
	{ "rls", 3 },
	{ "rrs", 3 },
	{ "ris", 3 },
	{ "ils", 3 },
	{ "irs", 3 },
	{ "iis", 3 },
	{ "",   -1 }
};

static ValidMode sfind_valid [] = {
	{ "ssr", 3 },
	{ "ssc", 3 },
	{ "",   -1 }
};

static ValidMode sord_valid [] = {
	{ "s-r", 2 },
	{ "s-c", 2 },
	{ "",   -1 }
};

static ValidMode schr_valid [] = {
	{ "l-c", 2 },
	{ "L-c", 2 },
	{ "r-c", 2 },
	{ "i-c", 2 },
	{ "",   -1 }
};

static ValidMode anew_valid [] = {
	{ "--c", 1 },
	{ "",   -1 }
};

static ValidMode alen_valid [] = {
	{ "a-r", 2 },
	{ "a-c", 2 },
	{ "",   -1 }
};

static ValidMode apush_valid [] = {
	{ "a--", 1 },
	{ "",   -1 }
};

static ValidMode apop_valid [] = {
	{ "--c", 1 },
	{ "",   -1 }
};

static ValidMode acmp_valid [] = {
	{ "aa-", 2 },
	{ "",   -1 }
};

static ValidMode aadd_valid [] = {
	{ "aac", 3 },
	{ "",   -1 }
};

static ValidMode amul_valid [] = {
	{ "L-a", 2 },
	{ "lac", 3 },
	{ "rac", 3 },
	{ "iac", 3 },
	{ "",   -1 }
};

static ValidMode acopy_valid [] = {
	{ "a-c", 2 },
	{ "",   -1 }
};

static ValidMode aindex_valid [] = {
	{ "L-a", 2 },
	{ "lac", 3 },
	{ "rac", 3 },
	{ "iac", 3 },
	{ "",   -1 }
};

static ValidMode ainsert_valid [] = {
	{ "L-a", 2 },
	{ "lla", 3 },
	{ "lra", 3 },
	{ "lca", 3 },
	{ "rla", 3 },
	{ "rra", 3 },
	{ "rca", 3 },
	{ "ila", 3 },
	{ "ira", 3 },
	{ "ica", 3 },
	{ "",   -1 }
};

static ValidMode aslice_valid [] = {
	{ "lla", 3 },
	{ "lra", 3 },
	{ "lia", 3 },
	{ "rla", 3 },
	{ "rra", 3 },
	{ "ria", 3 },
	{ "ila", 3 },
	{ "ira", 3 },
	{ "iia", 3 },
	{ "",   -1 }
};

static ValidMode afind_valid [] = {
	{ "L-a", 2 },
	{ "lar", 3 },
	{ "lac", 3 },
	{ "rar", 3 },
	{ "rac", 3 },
	{ "car", 3 },
	{ "cac", 3 },
	{ "",   -1 }
};

static ValidMode asort_valid [] = {
	{ "a-c", 2 },
	{ "",   -1 }
};

ValidMode * opvalid [256] = {
	halt_valid,	nop_valid,	bra_valid,	bgt_valid,
	bge_valid,	blt_valid,	ble_valid,	beq_valid,
	bne_valid,	beof_valid,	call_valid,	ret_valid,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	inew_valid,	iabs_valid,	ipush_valid,	ipop_valid,
	icmp_valid,	iread_valid,	iprint_valid,	iadd_valid,
	isub_valid,	imul_valid,	idiv_valid,	imod_valid,
	iand_valid,	ior_valid,	ixor_valid,	ilshift_valid,
	irshift_valid,	icopy_valid,	itod_valid,	itos_valid,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	dnew_valid,	dabs_valid,	dpush_valid,	dpop_valid,
	dcmp_valid,	dread_valid,	dprint_valid,	dadd_valid,
	dsub_valid,	dmul_valid,	ddiv_valid,	NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		dtoi_valid,	dcopy_valid,	dtos_valid,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	snew_valid,	slen_valid,	spush_valid,	spop_valid,
	scmp_valid,	sread_valid,	sprint_valid,	sadd_valid,
	ssub_valid,	smul_valid,	NULL,		slshift_valid,
	srshift_valid,	NULL,		NULL,		NULL,
	NULL,		stoi_valid,	stod_valid,	scopy_valid,
	sindex_valid,	sinsert_valid,	sslice_valid,	sfind_valid,
	sord_valid,	schr_valid,	NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	anew_valid,	alen_valid,	apush_valid,	apop_valid,
	acmp_valid,	NULL,		NULL,		aadd_valid,
	NULL,		amul_valid,	NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		acopy_valid,
	aindex_valid,	ainsert_valid,	aslice_valid,	afind_valid,
	NULL,		NULL,		asort_valid,	NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL,
	NULL,		NULL,		NULL,		NULL
};

